Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4423)
@@ -250,454 +491,4 @@
     #endregion
 
-    #region IExecutable Methods
-    public void Pause() {
-      throw new NotSupportedException();
-    }
-
-    public void Prepare() {
-      if (experiment != null) {
-        StopResultPolling();
-        experiment.Prepare();
-        this.ExecutionState = Core.ExecutionState.Prepared;
-        OnPrepared();
-      }
-    }
-
-    public void Start() {
-      OnStarted();
-      ExecutionTime = new TimeSpan();
-      lastUpdateTime = DateTime.Now;
-      this.ExecutionState = Core.ExecutionState.Started;
-
-      Thread t = new Thread(() => {
-        using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
-          try {
-            RootJobItem = ToJobItem(RootJob);
-
-            IEnumerable<string> groups = ResourceGroups;
-            SerializedJob serializedJob = RootJobItem.ToSerializedJob();
-            ResponseObject<JobDto> response = service.Obj.AddJobWithGroupStrings(serializedJob, groups);
-
-            if (response.StatusMessage != ResponseStatus.Ok) {
-              throw new Exception(response.StatusMessage.ToString());
-            } else {
-              RootJobItem.JobDto = response.Obj;
-              LogMessage(RootJobItem.JobDto.Id, "Job sent to Hive");
-
-              StartResultPolling();
-            }
-          }
-          catch (Exception e) {
-            LogMessage("Error: Starting HiveExperiment failed: " + e.Message);
-            this.ExecutionState = Core.ExecutionState.Stopped;
-            OnStopped();
-          }
-        }
-      });
-      t.Start();
-    }
-
-    public void Stop() {
-      if (IsPollingResults)
-        StopResultPolling();
-      this.ExecutionState = Core.ExecutionState.Stopped;
-      OnStopped();
-    }
-    #endregion
-    
-    #region Job Management
-    public void RefreshJobTree() {
-      this.RootJob = CreateJobTree(this.Experiment);
-    }
-    
-    private IJob CreateJobTree(IOptimizer optimizer) {
-      IJob job = null;
-      if (optimizer is HeuristicLab.Optimization.Experiment) {
-        HeuristicLab.Optimization.Experiment exp = (HeuristicLab.Optimization.Experiment)optimizer;
-        ExperimentJob expJob = new ExperimentJob(exp);
-        foreach (IOptimizer opt in exp.Optimizers) {
-          expJob.AddChildJob(CreateJobTree(opt));
-        }
-        job = expJob;
-      } else if (optimizer is BatchRun) {
-        job = new BatchRunJob(optimizer);
-      } else {
-        job = new OptimizerJob(optimizer);
-      }
-      return job;
-    }
-
-    private JobItem ToJobItem(IJob j) {
-      return new JobItem() {
-        Job = j,
-        JobDto = new JobDto() {
-          State = JobState.Offline,
-          PluginsNeeded = HivePluginInfoDto.FindPluginsNeeded(j.GetType())
-        }
-      };
-    }
-
-    /// <summary>
-    /// Updates all JobItems with the results
-    /// if one is finished, the serialized job is downloaded and updated
-    /// </summary>
-    /// <param name="jobResultList"></param>
-    private void UpdateJobItems(JobResultList jobResultList) {
-      if (RootJobItem == null) {
-        var rootResults = jobResultList.Where(res => !res.ParentJobId.HasValue);
-        if (rootResults.Count() > 0) {
-          RootJobItem = new JobItem(rootResults.First());
-        } else {
-          LogMessage("Error: Could not find JobResult for RootJobItem");
-          return;
-        }
-      }
-
-      using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
-        foreach (JobResult jobResult in jobResultList) {
-          JobItem jobItem = FindJobItem(RootJobItem, jobResult.Id);
-          if (jobItem != null) {
-            jobItem.UpdateJob(jobResult);
-            if (jobItem.JobDto.State == JobState.Finished && !jobItem.IsFinalResultAvailable) {
-              // job is finished but the final result was not yet downloaded
-              SerializedJob serializedJob = service.Obj.GetLastSerializedResult(jobResult.Id).Obj;
-              jobItem.Job = XmlParser.Deserialize<IJob>(new MemoryStream(serializedJob.SerializedJobData));
-              UpdateChildJobs(jobItem);
-              this.Experiment.Runs.AddRange(((OptimizerJob)jobItem.Job).Optimizer.Runs);
-              //ReplaceOptimizerInExperiment(jobItem.JobDto.Id, jobItem.Job);
-            }
-          } else {
-            // job does not yet exist locally
-            JobItem parentJobItem = FindJobItem(RootJobItem, jobResult.ParentJobId.Value);
-            if (parentJobItem != null) {
-              LogMessage(jobResult.Id, "Creating JobItem");
-              SerializedJob serializedJob = service.Obj.GetLastSerializedResult(jobResult.Id).Obj;
-              JobItem newJobItem = new JobItem();
-              newJobItem.JobDto = serializedJob.JobInfo;
-              newJobItem.Job = XmlParser.Deserialize<IJob>(new MemoryStream(serializedJob.SerializedJobData));
-              parentJobItem.AddChildJob(newJobItem);
-              if (newJobItem.JobDto.State == JobState.Finished && newJobItem.IsFinalResultAvailable) {
-                this.Experiment.Runs.AddRange(((OptimizerJob)newJobItem.Job).Optimizer.Runs);
-                UpdateChildJobs(newJobItem);
-                //ReplaceOptimizerInExperiment(jobItem.JobDto.Id, jobItem.Job);
-              }
-            } else {
-              LogMessage("Error: Could not update JobResult for " + jobResult.Id);
-            }
-          }
-        }
-      }
-    }
-
-    /// <summary>
-    /// Updates the ChildJobItems of a JobItem according to the IJob.ChildJobs of JobItem.Job (pretty confusing, right)
-    /// </summary>
-    /// <param name="jobItem"></param>
-    private void UpdateChildJobs(JobItem jobItem) {
-      List<JobItem> newJobItems = new List<JobItem>();
-      foreach (IJob job in jobItem.Job.ChildJobs) {
-        if (!jobItem.ReplaceChildJob(job)) {
-          newJobItems.Add(ToJobItem(job));
-        }
-      }
-      foreach (JobItem item in newJobItems) {
-        jobItem.AddChildJob(item);
-      }
-    }
-
-    private JobItem FindJobItem(JobItem parentJobItem, Guid jobId) {
-      if (parentJobItem.JobDto.Id == jobId) {
-        return parentJobItem;
-      } else {
-        foreach (JobItem child in parentJobItem.ChildJobItems) {
-          JobItem result = FindJobItem(child, jobId);
-          if (result != null)
-            return result;
-        }
-      }
-      return null;
-    }
-
-    private void JobItem_JobStateChanged(object sender, EventArgs e) {
-      JobItem jobItem = (JobItem)sender;
-
-      Thread t = new Thread(() => {
-        try {
-          if (jobItem.JobDto.State == JobState.Finished) {
-            FetchAndUpdateJob(jobItem.JobDto.Id);
-          } else if (jobItem.JobDto.State == JobState.Failed) {
-            
-          }
-        }
-        catch (Exception ex) {
-          LogMessage("JobItem_JobStateChanged failed badly: " + ex.Message);
-        }
-      });
-      t.Start();
-    }
-
-    /// <summary>
-    /// Fetches the finished job from the server and updates the jobItem
-    /// </summary>
-    private void FetchAndUpdateJob(Guid jobId) {
-      bool tryagain = false;
-      LogMessage(jobId, "FetchAndUpdateJob started");
-      if (fetchJobSemaphore.WaitOne(new TimeSpan(0, 2, 0))) {
-
-        try {
-          using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
-            ResponseObject<SerializedJob> jobResponse = service.Obj.GetLastSerializedResult(jobId);
-            IJob restoredObject = XmlParser.Deserialize<IJob>(new MemoryStream(jobResponse.Obj.SerializedJobData));
-            IOptimizer restoredOptimizer = ((OptimizerJob)restoredObject).Optimizer;
-            LogMessage(jobId, "FetchAndUpdateJob ended");
-          }
-        }
-        catch (Exception e) {
-          LogMessage(jobId, "FetchAndUpdateJob failed: " + e.Message + ". Will try again!");
-          tryagain = true;
-        }
-        finally {
-          fetchJobSemaphore.Release();
-        }
-      } else {
-        LogMessage(jobId, "FetchAndUpdateJob timed out. Will try again!");
-        tryagain = true;
-      }
-
-      if (tryagain) {
-        FetchAndUpdateJob(jobId);
-      }
-    }
-
-    public void AbortJob(Guid jobId) {
-      using (Disposable<IClientFacade> service = ServiceLocator.Instance.ClientFacadePool.GetService()) {
-        Response response = service.Obj.AbortJob(jobId);
-        LogMessage(jobId, "Aborting Job: " + response.StatusMessage);
-      }
-    }
-    #endregion
-
-    #region Result Polling
-    public void StartResultPolling() {
-      this.stopResultsPollingPending = false;
-      this.IsPollingResults = true;
-      resultPollingThread = new Thread(RunResultPollingThread);
-      if (resultPollingThread.ThreadState != System.Threading.ThreadState.Running)
-        resultPollingThread.Start();
-    }
-
-    public void StopResultPolling() {
-      this.stopResultsPollingPending = true;
-      if (resultPollingThread != null) {
-        if (resultPollingThread.ThreadState == System.Threading.ThreadState.WaitSleepJoin) {
-          resultPollingThread.Interrupt();
-        }
-        resultPollingThread.Join();
-      }
-      this.stopResultsPollingPending = false;
-    }
-
-    private void RunResultPollingThread() {
-      try {
-        do {
-          if (RootJobItem.JobDto.State != JobState.Finished) {
-            using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
-              LogMessage("Polling results");
-              try {
-                ResponseObject<JobResultList> response = service.Obj.GetChildJobResults(RootJobItem.JobDto.Id, true, true);
-                if (response.StatusMessage == ResponseStatus.Ok) {
-                  JobResultList jobItemList = response.Obj;
-                  UpdateJobItems(jobItemList);
-
-                  LogMessage("Polling successfully finished");
-                } else {
-                  throw new Exception(response.StatusMessage.ToString());
-                }
-              }
-              catch (Exception e) {
-                LogMessage("Polling results failed: " + e.Message);
-              }
-            }
-            Thread.Sleep(resultPollingIntervalMs);
-          } else {
-            // all the jobs have been sent to hive, but non are to query any more (all finished or failed)
-            this.stopResultsPollingPending = true;
-          }
-        } while (!this.stopResultsPollingPending);
-      }
-      catch (ThreadInterruptedException) {
-        // thread has been interuppted
-      }
-      catch (Exception e) {
-        LogMessage("Result Polling Thread failed badly: " + e.Message);
-      }
-      finally {
-        this.IsPollingResults = false;
-      }
-    }
-
-    #endregion
-
-    #region Snapshots
-
-    //private void UpdateSnapshot(ResponseObject<SerializedJob> response) {
-    //  JobItem jobItem = jobItems.Single(x => x.JobDto.Id == response.Obj.JobInfo.Id);
-    //  jobItem.LatestSnapshot = response;
-    //}
-
-    //public void RequestSnapshot(Guid jobId) {
-    //  Thread t = new Thread(() => {
-    //    IClientFacade clientFacade = null;
-    //    try {
-    //      clientFacade = CreateStreamedClientFacade();
-
-    //      ResponseObject<SerializedJob> response;
-    //      int retryCount = 0;
-
-    //      Response snapShotResponse = clientFacade.RequestSnapshot(jobId);
-    //      if (snapShotResponse.StatusMessage == ResponseStatus.RequestSnapshot_JobIsNotBeeingCalculated) {
-    //        // job already finished
-    //        Logger.Debug("HiveExperiment: Abort - GetLastResult(false)");
-    //        response = clientFacade.GetLastSerializedResult(jobId, false, false);
-    //        Logger.Debug("HiveExperiment: Abort - Server: " + response.StatusMessage);
-    //      } else {
-    //        // server sent snapshot request to client
-    //        // poll until snapshot is ready
-    //        do {
-    //          Thread.Sleep(snapshotPollingIntervalMs);
-    //          Logger.Debug("HiveExperiment: Abort - GetLastResult(true)");
-    //          response = clientFacade.GetLastSerializedResult(jobId, false, true);
-    //          Logger.Debug("HiveExperiment: Abort - Server: " + response.StatusMessage);
-    //          retryCount++;
-    //          // loop while
-    //          // 1. problem with communication with server
-    //          // 2. job result not yet ready
-    //        } while (
-    //          (retryCount < maxSnapshotRetries) && (
-    //          response.StatusMessage == ResponseStatus.GetLastSerializedResult_JobResultNotYetThere)
-    //          );
-    //      }
-    //      if (response.StatusMessage == ResponseStatus.Ok) {
-    //        LogMessage(jobId, "Snapshot polling successfull for job " + jobId);
-    //        //UpdateSnapshot(response);
-    //      } else {
-    //        LogMessage(jobId, "Error: Polling of Snapshot failed for job " + jobId + ": " + response.StatusMessage);
-    //      }
-    //    }
-    //    catch (Exception e) {
-    //      LogMessage("RequestSnapshot Thread failed badly: " + e.Message);
-    //      Logger.Error("RequestSnapshot Thread failed badly: " + e.Message);
-    //    }
-    //    finally {
-    //      ServiceLocator.DisposeClientFacade(clientFacade);
-    //    }
-    //  });
-    //  t.Start();
-    //}
-
-    //void JobItem_SnapshotRequestedStateChanged(object sender, EventArgs e) {
-    //  JobItem jobItem = (JobItem)sender;
-    //  if (jobItem.SnapshotRequestedState == SnapshotRequestedState.Requested) {
-    //    RequestSnapshot(jobItem.JobDto.Id);
-    //  }
-    //}
-
-    #endregion
-
-    #region Eventhandler
-
-    public event EventHandler ExecutionTimeChanged;
-    private void OnExecutionTimeChanged() {
-      EventHandler handler = ExecutionTimeChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler ExecutionStateChanged;
-    private void OnExecutionStateChanged() {
-      LogMessage("ExecutionState changed to " + executionState.ToString());
-      EventHandler handler = ExecutionStateChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler<EventArgs<Exception>> ExceptionOccurred;
-
-    public event EventHandler Started;
-    private void OnStarted() {
-      LogMessage("Started");
-      timer.Start();
-      EventHandler handler = Started;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler Stopped;
-    private void OnStopped() {
-      timer.Stop();
-      LogMessage("Stopped");
-      EventHandler handler = Stopped;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler Paused;
-    private void OnPaused() {
-      timer.Stop();
-      LogMessage("Paused");
-      EventHandler handler = Paused;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler Prepared;
-    protected virtual void OnPrepared() {
-      LogMessage("Prepared");
-      EventHandler handler = Prepared;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler ResourceIdsChanged;
-    protected virtual void OnResourceIdsChanged() {
-      EventHandler handler = ResourceIdsChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler ExperimentChanged;
-    protected virtual void OnExperimentChanged() {
-      LogMessage("Experiment changed");
-      EventHandler handler = ExperimentChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler RootJobChanged;
-    private void OnRootJobChanged() {
-      EventHandler handler = RootJobChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler RootJobItemChanged;
-    private void OnRootJobItemChanged() {
-      EventHandler handler = RootJobItemChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public event EventHandler IsResultsPollingChanged;
-    private void OnIsPollingResultsChanged() {
-      if (this.IsPollingResults) {
-        LogMessage("Results Polling Started");
-        timer.Start();
-      } else {
-        LogMessage("Results Polling Stopped");
-        timer.Stop();
-      }
-      EventHandler handler = IsResultsPollingChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    void HiveExperiment_RootJobChanged(object sender, EventArgs e) {
-      this.Experiment = (Optimization.Experiment)((ExperimentJob)rootJobItem.Job).Optimizer;
-    }
-
-    void rootJobItem_FinalResultAvailable(object sender, EventArgs e) {
-      this.Experiment = (Optimization.Experiment)((ExperimentJob)rootJobItem.Job).Optimizer;
-    }
-    #endregion
-    
     #region Logging
     private void LogMessage(string message) {
@@ -719,16 +510,76 @@
     /// Downloads the root job from hive and sets the experiment, rootJob and rootJobItem
     /// </summary>
-    public void LoadExperimentFromHive() {
+    public void LoadHiveJob() {
+      progress = new Progress();
+      try {
+        IsProgressing = true;
+        int totalJobCount = 0;
+        int jobCount = 0;
+        progress.Status = "Connecting to Server...";
+        using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
+          // fetch all JobDto objects to create the full tree of tree of HiveJob objects
+          progress.Status = "Downloading list of jobs...";
+          JobResultList allResults = service.Obj.GetChildJobResults(rootJobId.Value, true, true).Obj;
+          totalJobCount = allResults.Count;
+
+          // download them first
+          IDictionary<Guid, SerializedJob> allSerializedJobs = new Dictionary<Guid, SerializedJob>();
+          foreach (JobResult jobResult in allResults) {
+            jobCount++;
+            progress.Status = string.Format("Downloading {0} of {1} jobs...", jobCount, totalJobCount);
+            allSerializedJobs.Add(jobResult.Id, service.Obj.GetLastSerializedResult(jobResult.Id).Obj);
+            progress.ProgressValue = (double)jobCount / totalJobCount;
+          }
+
+          jobCount = 1;
+          progress.Status = string.Format("Deserializing {0} of {1} jobs... ({2} kb)", jobCount, totalJobCount, allSerializedJobs[this.rootJobId.Value].SerializedJobData.Count() / 1024);
+          this.HiveJob = new HiveJob(allSerializedJobs[this.rootJobId.Value], false);
+          allSerializedJobs.Remove(this.rootJobId.Value); // reduce memory footprint
+          progress.ProgressValue = (double)jobCount / totalJobCount;
+
+          if (this.HiveJob.JobDto.DateFinished.HasValue) {
+            this.ExecutionTime = this.HiveJob.JobDto.DateFinished.Value - this.HiveJob.JobDto.DateCreated.Value;
+            this.lastUpdateTime = this.HiveJob.JobDto.DateFinished.Value;
+          } else {
+            this.ExecutionTime = DateTime.Now - this.HiveJob.JobDto.DateCreated.Value;
+            this.lastUpdateTime = DateTime.Now;
+          }
+
+          // build child-job tree
+          LoadChildResults(service.Obj, this.HiveJob, allResults, allSerializedJobs, progress, totalJobCount, ref jobCount);
+          StartResultPolling();
+        }
+      }
+      catch (Exception e) {
+        OnExceptionOccured(e);
+      }
+      finally {
+        IsProgressing = false;
+      }
+    }
+
+    private void LoadChildResults(IClientFacade service, HiveJob parentHiveJob, JobResultList allResults, IDictionary<Guid, SerializedJob> allSerializedJobs, IProgress progress, int totalJobCount, ref int jobCount) {
+      IEnumerable<JobResult> childResults = from result in allResults
+                                            where result.ParentJobId.HasValue && result.ParentJobId.Value == parentHiveJob.JobDto.Id
+                                            orderby result.DateCreated ascending
+                                            select result;
+      foreach (JobResult jobResult in childResults) {
+        jobCount++;
+        progress.Status = string.Format("Deserializing {0} of {1} jobs ({2} kb)...", jobCount, totalJobCount, allSerializedJobs[jobResult.Id].SerializedJobData.Count() / 1024);
+        OptimizerJob optimizerJob = SerializedJob.Deserialize<OptimizerJob>(allSerializedJobs[jobResult.Id].SerializedJobData);
+        progress.ProgressValue = (double)jobCount / totalJobCount;
+        HiveJob childHiveJob = new HiveJob(optimizerJob, false);
+        parentHiveJob.AddChildHiveJob(childHiveJob);
+        childHiveJob.JobDto = allSerializedJobs[jobResult.Id].JobInfo;
+        allSerializedJobs.Remove(jobResult.Id); // reduce memory footprint
+        if(jobCount % 10 == 0) GC.Collect(); // this is needed or otherwise HL takes over the system when the number of jobs is high
+        LoadChildResults(service, childHiveJob, allResults, allSerializedJobs, progress, totalJobCount, ref jobCount);
+      }
+    }
+
+    private OptimizerJob LoadOptimizerJob(Guid jobId) {
       using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
-        ResponseObject<SerializedJob> response = service.Obj.GetLastSerializedResult(RootJobItem.JobDto.Id);
-        IJob job = XmlParser.Deserialize<IJob>(new MemoryStream(response.Obj.SerializedJobData));
-        RootJob = job;
-        RootJobItem.JobDto = response.Obj.JobInfo;
-        this.Experiment = (Optimization.Experiment)((OptimizerJob)job).Optimizer;
-        if (rootJobItem.JobDto.State == JobState.Finished) {
-          // set execution time and finish up
-        } else if (rootJobItem.JobDto.State != JobState.Aborted && rootJobItem.JobDto.State != JobState.Failed) {
-          this.ExecutionState = Core.ExecutionState.Started;
-        }
+        ResponseObject<SerializedJob> serializedJob = service.Obj.GetLastSerializedResult(jobId);
+        return SerializedJob.Deserialize<OptimizerJob>(serializedJob.Obj.SerializedJobData);
       }
     }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperimentList.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperimentList.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperimentList.cs	(revision 4423)
@@ -21,5 +21,5 @@
 
     public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
-      HiveExperimentList clone = (HiveExperimentList)base.Clone(cloner);
+      HiveExperiment clone = (HiveExperiment)base.Clone(cloner);
       return clone;
     }
